diff --git a/compiler/typecheck/TcHsType.lhs b/compiler/typecheck/TcHsType.lhs
index b7cd841..f629c2e 100644
--- a/compiler/typecheck/TcHsType.lhs
+++ b/compiler/typecheck/TcHsType.lhs
@@ -5,44 +5,38 @@
 \section[TcMonoType]{Typechecking user-specified @MonoTypes@}
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcHsType (
-	tcHsSigType, tcHsSigTypeNC, tcHsDeriv, tcHsVectInst, 
-	tcHsInstHead, 
-	UserTypeCtxt(..), 
+        tcHsSigType, tcHsSigTypeNC, tcHsDeriv, tcHsVectInst, 
+        tcHsInstHead, 
+        UserTypeCtxt(..), 
 
                 -- Type checking type and class decls
-	kcLookupKind, kcTyClTyVars, tcTyClTyVars,
+        kcLookupKind, kcTyClTyVars, tcTyClTyVars,
         tcHsConArgType, tcDataKindSig, 
         tcClassSigType,
 
-		-- Kind-checking types
+                -- Kind-checking types
                 -- No kind generalisation, no checkValidType
-	KindCheckingStrategy(..), kcStrategy, kcStrategyFamDecl,
+        KindCheckingStrategy(..), kcStrategy, kcStrategyFamDecl,
         kcHsTyVarBndrs, tcHsTyVarBndrs, 
         tcHsLiftedType, tcHsOpenType,
-	tcLHsType, tcCheckLHsType, 
+        tcLHsType, tcCheckLHsType, 
         tcHsContext, tcInferApps, tcHsArgTys,
 
         kindGeneralize, checkKind,
 
-		-- Sort-checking kinds
-	tcLHsKind, 
+                -- Sort-checking kinds
+        tcLHsKind, 
 
-		-- Pattern type signatures
-	tcHsPatSigType, tcPatSig
+                -- Pattern type signatures
+        tcHsPatSigType, tcPatSig
    ) where
 
 #include "HsVersions.h"
 
-#ifdef GHCI 	/* Only if bootstrapped */
-import {-# SOURCE #-}	TcSplice( tcSpliceType )
+#ifdef GHCI     /* Only if bootstrapped */
+import {-# SOURCE #-}   TcSplice( tcSpliceType )
 #endif
 
 import HsSyn
@@ -81,31 +75,31 @@ import PrelNames( ipClassName, funTyConKey )
 \end{code}
 
 
-	----------------------------
-		General notes
-	----------------------------
+        ----------------------------
+                General notes
+        ----------------------------
 
 Generally speaking we now type-check types in three phases
 
   1.  kcHsType: kind check the HsType
-	*includes* performing any TH type splices;
-	so it returns a translated, and kind-annotated, type
+        *includes* performing any TH type splices;
+        so it returns a translated, and kind-annotated, type
 
   2.  dsHsType: convert from HsType to Type:
-	perform zonking
-	expand type synonyms [mkGenTyApps]
-	hoist the foralls [tcHsType]
+        perform zonking
+        expand type synonyms [mkGenTyApps]
+        hoist the foralls [tcHsType]
 
   3.  checkValidType: check the validity of the resulting type
 
 Often these steps are done one after the other (tcHsSigType).
 But in mutually recursive groups of type and class decls we do
-	1 kind-check the whole group
-	2 build TyCons/Classes in a knot-tied way
-	3 check the validity of types in the now-unknotted TyCons/Classes
+        1 kind-check the whole group
+        2 build TyCons/Classes in a knot-tied way
+        3 check the validity of types in the now-unknotted TyCons/Classes
 
 For example, when we find
-	(forall a m. m a -> m a)
+        (forall a m. m a -> m a)
 we bind a,m to kind varibles and kind-check (m a -> m a).  This makes
 a get kind *, and m get kind *->*.  Now we typecheck (m a -> m a) in
 an environment that binds a and m suitably.
@@ -113,18 +107,18 @@ an environment that binds a and m suitably.
 The kind checker passed to tcHsTyVars needs to look at enough to
 establish the kind of the tyvar:
   * For a group of type and class decls, it's just the group, not
-	the rest of the program
+        the rest of the program
   * For a tyvar bound in a pattern type signature, its the types
-	mentioned in the other type signatures in that bunch of patterns
+        mentioned in the other type signatures in that bunch of patterns
   * For a tyvar bound in a RULE, it's the type signatures on other
-	universally quantified variables in the rule
+        universally quantified variables in the rule
 
 Note that this may occasionally give surprising results.  For example:
 
-	data T a b = MkT (a b)
+        data T a b = MkT (a b)
 
-Here we deduce			a::*->*,       b::*
-But equally valid would be	a::(*->*)-> *, b::*->*
+Here we deduce                  a::*->*,       b::*
+But equally valid would be      a::(*->*)-> *, b::*->*
 
 
 Validity checking
@@ -134,8 +128,8 @@ but not all:
 
 - During desugaring, we normalise by expanding type synonyms.  Only
   after this step can we check things like type-synonym saturation
-  e.g. 	type T k = k Int
-	type S a = a
+  e.g.  type T k = k Int
+        type S a = a
   Then (T S) is ok, because T is saturated; (T S) expands to (S Int);
   and then S is saturated.  This is a GHC extension.
 
@@ -158,15 +152,15 @@ the TyCon being defined.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
               Check types AND do validity checking
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 tcHsSigType, tcHsSigTypeNC :: UserTypeCtxt -> LHsType Name -> TcM Type
   -- NB: it's important that the foralls that come from the top-level
-  --	 HsForAllTy in hs_ty occur *first* in the returned type.
+  --     HsForAllTy in hs_ty occur *first* in the returned type.
   --     See Note [Scoped] with TcSigInfo
 tcHsSigType ctxt hs_ty
   = addErrCtxt (pprHsSigCtxt ctxt hs_ty) $
@@ -217,7 +211,7 @@ tcHsDeriv hs_ty
   = do { kind <- newMetaKindVar
        ; ty   <- tcCheckHsTypeAndGen hs_ty kind
                  -- Funny newtype deriving form
-                 -- 	forall a. C [a]
+                 --     forall a. C [a]
                  -- where C has arity 2. Hence any-kinded result
        ; ty   <- zonkSigType ty
        ; let (tvs, pred) = splitForAllTys ty
@@ -237,18 +231,18 @@ tcHsVectInst ty
   = failWithTc $ ptext (sLit "Malformed instance type")
 \end{code}
 
-	These functions are used during knot-tying in
-	type and class declarations, when we have to
- 	separate kind-checking, desugaring, and validity checking
+        These functions are used during knot-tying in
+        type and class declarations, when we have to
+        separate kind-checking, desugaring, and validity checking
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
             The main kind checker: no validity checks here
-%*									*
+%*                                                                      *
 %************************************************************************
-	
-	First a couple of simple wrappers for kcHsType
+        
+        First a couple of simple wrappers for kcHsType
 
 \begin{code}
 tcClassSigType :: LHsType Name -> TcM Type
@@ -348,7 +342,7 @@ tc_fun_type ty ty1 ty2 exp_kind@(EK _ ctxt)
 tc_hs_type :: HsType Name -> ExpKind -> TcM TcType
 tc_hs_type (HsParTy ty)        exp_kind = tc_lhs_type ty exp_kind
 tc_hs_type (HsDocTy ty _)      exp_kind = tc_lhs_type ty exp_kind
-tc_hs_type (HsQuasiQuoteTy {}) _ = panic "tc_hs_type: qq"	-- Eliminated by renamer
+tc_hs_type (HsQuasiQuoteTy {}) _ = panic "tc_hs_type: qq"       -- Eliminated by renamer
 tc_hs_type ty@(HsBangTy {})    _
     -- While top-level bangs at this point are eliminated (eg !(Maybe Int)),
     -- other kinds of bangs are not (eg ((!Maybe) Int)). These kinds of
@@ -509,7 +503,7 @@ tc_hs_type (HsCoreTy ty) exp_kind
        ; return ty }
 
 
-#ifdef GHCI	/* Only if bootstrapped */
+#ifdef GHCI     /* Only if bootstrapped */
 -- This looks highly suspect to me
 -- It will really only be fixed properly when we do the TH
 -- reorganisation so that type splices happen in the renamer
@@ -578,9 +572,9 @@ finish_tuple hs_ty tup_sort tau_tys exp_kind
 ---------------------------
 tcInferApps :: Outputable a
        => a 
-       -> TcKind			-- Function kind
-       -> [LHsType Name]		-- Arg types
-       -> TcM ([TcType], TcKind)	-- Kind-checked args
+       -> TcKind                        -- Function kind
+       -> [LHsType Name]                -- Arg types
+       -> TcM ([TcType], TcKind)        -- Kind-checked args
 tcInferApps the_fun fun_kind args
   = do { (args_w_kinds, res_kind) <- splitFunKind (ppr the_fun) fun_kind args
        ; args' <- tc_lhs_types args_w_kinds
@@ -590,8 +584,8 @@ tcCheckApps :: Outputable a
             => HsType Name     -- The type being checked (for err messages only)
             -> a               -- The function
             -> TcKind -> [LHsType Name]   -- Fun kind and arg types
-	    -> ExpKind 	                  -- Expected kind
-	    -> TcM [TcType]
+            -> ExpKind                    -- Expected kind
+            -> TcM [TcType]
 tcCheckApps hs_ty the_fun fun_kind args exp_kind
   = do { (arg_tys, res_kind) <- tcInferApps the_fun fun_kind args
        ; checkExpectedKind hs_ty res_kind exp_kind
@@ -612,7 +606,7 @@ splitFunKind the_fun fun_kind args
                                      ; return ((arg, exp_kind) : aks, rk) } }
  
     too_many_args = quotes the_fun <+>
-		    ptext (sLit "is applied to too many type arguments")
+                    ptext (sLit "is applied to too many type arguments")
 
 
 ---------------------------
@@ -677,7 +671,7 @@ tcTyVar name         -- Could be a tyvar, a tycon, or a datacon
         (kvs, ki_body) = splitForAllTys kind
 
 tcClass :: Name -> TcM (Class, TcKind)
-tcClass cls 	-- Must be a class
+tcClass cls     -- Must be a class
   = do { thing <- tcLookup cls
        ; case thing of
            AThing kind -> return (aThingErr "tcClass" cls, kind)
@@ -760,14 +754,14 @@ zonkSigType ty
     go (AppTy fun arg)   = do fun' <- go fun
                               arg' <- go arg
                               return (mkAppTy fun' arg')
-		-- NB the mkAppTy; we might have instantiated a
-		-- type variable to a type constructor, so we need
-		-- to pull the TyConApp to the top.
+                -- NB the mkAppTy; we might have instantiated a
+                -- type variable to a type constructor, so we need
+                -- to pull the TyConApp to the top.
 
-	-- The two interesting cases!
+        -- The two interesting cases!
     go (TyVarTy tyvar) | isTcTyVar tyvar = zonkTcTyVar tyvar
-		       | otherwise	 = TyVarTy <$> updateTyVarKindM go tyvar
-		-- Ordinary (non Tc) tyvars occur inside quantified types
+                       | otherwise       = TyVarTy <$> updateTyVarKindM go tyvar
+                -- Ordinary (non Tc) tyvars occur inside quantified types
 
     go (ForAllTy tv ty) = do { tv' <- zonkTcTyVarBndr tv
                              ; ty' <- go ty
@@ -870,8 +864,8 @@ Moreover
   * it cannot fail, 
   * it does no unifications
   * it does no validity checking, except for structural matters, such as
-	(a) spurious ! annotations.
-	(b) a class used as a type
+        (a) spurious ! annotations.
+        (b) a class used as a type
 
 Note [Kind of a type splice]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -893,8 +887,8 @@ Help functions for type applications
 
 \begin{code}
 addTypeCtxt :: LHsType Name -> TcM a -> TcM a
-	-- Wrap a context around only if we want to show that contexts.  
-	-- Omit invisble ones and ones user's won't grok
+        -- Wrap a context around only if we want to show that contexts.  
+        -- Omit invisble ones and ones user's won't grok
 addTypeCtxt (L _ ty) thing 
   = addErrCtxt doc thing
   where
@@ -902,9 +896,9 @@ addTypeCtxt (L _ ty) thing
 \end{code}
 
 %************************************************************************
-%*									*
-		Type-variable binders
-%*									*
+%*                                                                      *
+                Type-variable binders
+%*                                                                      *
 %************************************************************************
 
 Note [Kind-checking strategies]
@@ -1104,8 +1098,8 @@ kcScopedKindVars kv_ns thing_inside
 
 kcHsTyVarBndrs :: KindCheckingStrategy
                -> LHsTyVarBndrs Name 
-	       -> TcM (Kind, r)   -- the result kind, possibly with other info
-	       -> TcM (Kind, r)
+               -> TcM (Kind, r)   -- the result kind, possibly with other info
+               -> TcM (Kind, r)
 -- Used in getInitialKind
 kcHsTyVarBndrs strat (HsQTvs { hsq_kvs = kv_ns, hsq_tvs = hs_tvs }) thing_inside
   = do { kvs <- if skolem_kvs
@@ -1132,9 +1126,9 @@ kcHsTyVarBndrs strat (HsQTvs { hsq_kvs = kv_ns, hsq_tvs = hs_tvs }) thing_inside
     kc_hs_tv (UserTyVar n)
       = do { mb_thing <- tcLookupLcl_maybe n
            ; kind <- case mb_thing of
-               	       Just (AThing k)     -> return k
-               	       _ | default_to_star -> return liftedTypeKind
-               	         | otherwise       -> newMetaKindVar
+                       Just (AThing k)     -> return k
+                       _ | default_to_star -> return liftedTypeKind
+                         | otherwise       -> newMetaKindVar
            ; return (n, kind) }
     kc_hs_tv (KindedTyVar n k) 
       = do { kind <- tcLHsKind k
@@ -1149,8 +1143,8 @@ kcHsTyVarBndrs strat (HsQTvs { hsq_kvs = kv_ns, hsq_tvs = hs_tvs }) thing_inside
            ; return (n, kind) }
 
 tcHsTyVarBndrs :: LHsTyVarBndrs Name 
-	       -> ([TcTyVar] -> TcM r)
-	       -> TcM r
+               -> ([TcTyVar] -> TcM r)
+               -> TcM r
 -- Bind the kind variables to fresh skolem variables
 -- and type variables to skolems, each with a meta-kind variable kind
 tcHsTyVarBndrs (HsQTvs { hsq_kvs = kv_ns, hsq_tvs = hs_tvs }) thing_inside
@@ -1200,9 +1194,9 @@ kindGeneralize tkvs
                 -- Any type variables in tkvs will be in scope,
                 -- and hence in gbl_tvs, so after removing gbl_tvs
                 -- we should only have kind variables left
-		--
- 		-- BUT there is a smelly case (to be fixed when TH is reorganised)
-		--     f t = [| e :: $t |]
+                --
+                -- BUT there is a smelly case (to be fixed when TH is reorganised)
+                --     f t = [| e :: $t |]
                 -- When typechecking the body of the bracket, we typecheck $t to a
                 -- unification variable 'alpha', with no biding forall.  We don't
                 -- want to kind-quantify it!
@@ -1263,8 +1257,8 @@ kcTyClTyVars :: Name -> LHsTyVarBndrs Name -> TcM a -> TcM a
 -- when doing the initial kind-check.  
 kcTyClTyVars name (HsQTvs { hsq_kvs = kvs, hsq_tvs = hs_tvs }) thing_inside
   = kcScopedKindVars kvs $
-    do 	{ tc_kind <- kcLookupKind name
-	; let (arg_ks, _res_k) = splitKindFunTysN (length hs_tvs) tc_kind
+    do  { tc_kind <- kcLookupKind name
+        ; let (arg_ks, _res_k) = splitKindFunTysN (length hs_tvs) tc_kind
                      -- There should be enough arrows, because
                      -- getInitialKinds used the tcdTyVars
         ; name_ks <- zipWithM kc_tv hs_tvs arg_ks
@@ -1283,7 +1277,7 @@ kcTyClTyVars name (HsQTvs { hsq_kvs = kvs, hsq_tvs = hs_tvs }) thing_inside
            ; return (n, exp_k) }
 
 -----------------------
-tcTyClTyVars :: Name -> LHsTyVarBndrs Name	-- LHS of the type or class decl
+tcTyClTyVars :: Name -> LHsTyVarBndrs Name      -- LHS of the type or class decl
              -> ([TyVar] -> Kind -> TcM a) -> TcM a
 -- Used for the type variables of a type or class decl,
 -- on the second pass when constructing the final result
@@ -1320,25 +1314,25 @@ tcTyClTyVars tycon (HsQTvs { hsq_kvs = hs_kvs, hsq_tvs = hs_tvs }) thing_inside
 -----------------------------------
 tcDataKindSig :: Kind -> TcM [TyVar]
 -- GADT decls can have a (perhaps partial) kind signature
---	e.g.  data T :: * -> * -> * where ...
+--      e.g.  data T :: * -> * -> * where ...
 -- This function makes up suitable (kinded) type variables for 
 -- the argument kinds, and checks that the result kind is indeed *.
 -- We use it also to make up argument type variables for for data instances.
 tcDataKindSig kind
-  = do	{ checkTc (isLiftedTypeKind res_kind) (badKindSig kind)
-	; span <- getSrcSpanM
-	; us   <- newUniqueSupply 
-	; let uniqs = uniqsFromSupply us
-	; return [ mk_tv span uniq str kind 
-		 | ((kind, str), uniq) <- arg_kinds `zip` dnames `zip` uniqs ] }
+  = do  { checkTc (isLiftedTypeKind res_kind) (badKindSig kind)
+        ; span <- getSrcSpanM
+        ; us   <- newUniqueSupply 
+        ; let uniqs = uniqsFromSupply us
+        ; return [ mk_tv span uniq str kind 
+                 | ((kind, str), uniq) <- arg_kinds `zip` dnames `zip` uniqs ] }
   where
     (arg_kinds, res_kind) = splitKindFunTys kind
     mk_tv loc uniq str kind = mkTyVar name kind
-	where
-	   name = mkInternalName uniq occ loc
-	   occ  = mkOccName tvName str
-	  
-    dnames = map ('$' :) names	-- Note [Avoid name clashes for associated data types]
+        where
+           name = mkInternalName uniq occ loc
+           occ  = mkOccName tvName str
+          
+    dnames = map ('$' :) names  -- Note [Avoid name clashes for associated data types]
 
     names :: [String]
     names = [ c:cs | cs <- "" : names, c <- ['a'..'z'] ] 
@@ -1346,7 +1340,7 @@ tcDataKindSig kind
 badKindSig :: Kind -> SDoc
 badKindSig kind 
  = hang (ptext (sLit "Kind signature on data type declaration has non-* return kind"))
-	2 (ppr kind)
+        2 (ppr kind)
 \end{code}
 
 Note [Avoid name clashes for associated data types]
@@ -1369,15 +1363,15 @@ interface file.)
 
 
 %************************************************************************
-%*									*
-		Scoped type variables
-%*									*
+%*                                                                      *
+                Scoped type variables
+%*                                                                      *
 %************************************************************************
 
 
 tcAddScopedTyVars is used for scoped type variables added by pattern
 type signatures
-	e.g.  \ ((x::a), (y::a)) -> x+y
+        e.g.  \ ((x::a), (y::a)) -> x+y
 They never have explicit kinds (because this is source-code only)
 They are mutable (because they can get bound to a more specific type).
 
@@ -1392,7 +1386,7 @@ The current not-very-good plan is to
   * do kind inference
   * bring the kinded type vars into scope
   * BUT throw away the kind-checked type
-  	(we'll kind-check it again when we type-check the pattern)
+        (we'll kind-check it again when we type-check the pattern)
 
 This is bad because throwing away the kind checked type throws away
 its splices.  But too bad for now.  [July 03]
@@ -1401,33 +1395,33 @@ Historical note:
     We no longer specify that these type variables must be univerally 
     quantified (lots of email on the subject).  If you want to put that 
     back in, you need to
-	a) Do a checkSigTyVars after thing_inside
-	b) More insidiously, don't pass in expected_ty, else
-	   we unify with it too early and checkSigTyVars barfs
-	   Instead you have to pass in a fresh ty var, and unify
-	   it with expected_ty afterwards
+        a) Do a checkSigTyVars after thing_inside
+        b) More insidiously, don't pass in expected_ty, else
+           we unify with it too early and checkSigTyVars barfs
+           Instead you have to pass in a fresh ty var, and unify
+           it with expected_ty afterwards
 
 \begin{code}
 tcHsPatSigType :: UserTypeCtxt
-	       -> HsWithBndrs (LHsType Name)  -- The type signature
-	      -> TcM ( Type                   -- The signature
+               -> HsWithBndrs (LHsType Name)  -- The type signature
+              -> TcM ( Type                   -- The signature
                       , [(Name, TcTyVar)] )   -- The new bit of type environment, binding
-				              -- the scoped type variables
+                                              -- the scoped type variables
 -- Used for type-checking type signatures in
--- (a) patterns 	  e.g  f (x::Int) = e
+-- (a) patterns           e.g  f (x::Int) = e
 -- (b) result signatures  e.g. g x :: Int = e
 -- (c) RULE forall bndrs  e.g. forall (x::Int). f x = x
 
 tcHsPatSigType ctxt (HsWB { hswb_cts = hs_ty, hswb_kvs = sig_kvs, hswb_tvs = sig_tvs })
   = addErrCtxt (pprHsSigCtxt ctxt hs_ty) $
-    do	{ kvs <- mapM new_kv sig_kvs
+    do  { kvs <- mapM new_kv sig_kvs
         ; tvs <- mapM new_tv sig_tvs
         ; let ktv_binds = (sig_kvs `zip` kvs) ++ (sig_tvs `zip` tvs)
-	; sig_ty <- tcExtendTyVarEnv2 ktv_binds $
+        ; sig_ty <- tcExtendTyVarEnv2 ktv_binds $
                     tcHsLiftedType hs_ty
         ; sig_ty <- zonkSigType sig_ty
-	; checkValidType ctxt sig_ty 
-	; return (sig_ty, ktv_binds) }
+        ; checkValidType ctxt sig_ty 
+        ; return (sig_ty, ktv_binds) }
   where
     new_kv name = new_tkv name superKind
     new_tv name = do { kind <- newMetaKindVar
@@ -1439,49 +1433,49 @@ tcHsPatSigType ctxt (HsWB { hswb_cts = hs_ty, hswb_kvs = sig_kvs, hswb_tvs = sig
           _              -> newSigTyVar name kind  -- See Note [Unifying SigTvs]
 
 tcPatSig :: UserTypeCtxt
-	 -> HsWithBndrs (LHsType Name)
-	 -> TcSigmaType
-	 -> TcM (TcType,	    -- The type to use for "inside" the signature
-		 [(Name, TcTyVar)], -- The new bit of type environment, binding
-				    -- the scoped type variables
+         -> HsWithBndrs (LHsType Name)
+         -> TcSigmaType
+         -> TcM (TcType,            -- The type to use for "inside" the signature
+                 [(Name, TcTyVar)], -- The new bit of type environment, binding
+                                    -- the scoped type variables
                  HsWrapper)         -- Coercion due to unification with actual ty
                                     -- Of shape:  res_ty ~ sig_ty
 tcPatSig ctxt sig res_ty
-  = do	{ (sig_ty, sig_tvs) <- tcHsPatSigType ctxt sig
-    	-- sig_tvs are the type variables free in 'sig', 
-	-- and not already in scope. These are the ones
-	-- that should be brought into scope
+  = do  { (sig_ty, sig_tvs) <- tcHsPatSigType ctxt sig
+        -- sig_tvs are the type variables free in 'sig', 
+        -- and not already in scope. These are the ones
+        -- that should be brought into scope
 
-	; if null sig_tvs then do {
-		-- Just do the subsumption check and return
+        ; if null sig_tvs then do {
+                -- Just do the subsumption check and return
                   wrap <- tcSubType PatSigOrigin ctxt res_ty sig_ty
-		; return (sig_ty, [], wrap)
+                ; return (sig_ty, [], wrap)
         } else do
-		-- Type signature binds at least one scoped type variable
-	
-		-- A pattern binding cannot bind scoped type variables
+                -- Type signature binds at least one scoped type variable
+        
+                -- A pattern binding cannot bind scoped type variables
                 -- It is more convenient to make the test here
                 -- than in the renamer
-	{ let in_pat_bind = case ctxt of
-				BindPatSigCtxt -> True
-				_              -> False
-	; when in_pat_bind (addErr (patBindSigErr sig_tvs))
-
-		-- Check that all newly-in-scope tyvars are in fact
-		-- constrained by the pattern.  This catches tiresome
-		-- cases like	
-		--	type T a = Int
-		--	f :: Int -> Int
-		-- 	f (x :: T a) = ...
-		-- Here 'a' doesn't get a binding.  Sigh
-	; let bad_tvs = [ tv | (_, tv) <- sig_tvs
+        { let in_pat_bind = case ctxt of
+                                BindPatSigCtxt -> True
+                                _              -> False
+        ; when in_pat_bind (addErr (patBindSigErr sig_tvs))
+
+                -- Check that all newly-in-scope tyvars are in fact
+                -- constrained by the pattern.  This catches tiresome
+                -- cases like   
+                --      type T a = Int
+                --      f :: Int -> Int
+                --      f (x :: T a) = ...
+                -- Here 'a' doesn't get a binding.  Sigh
+        ; let bad_tvs = [ tv | (_, tv) <- sig_tvs
                              , not (tv `elemVarSet` exactTyVarsOfType sig_ty) ]
-	; checkTc (null bad_tvs) (badPatSigTvs sig_ty bad_tvs)
+        ; checkTc (null bad_tvs) (badPatSigTvs sig_ty bad_tvs)
 
-	-- Now do a subsumption check of the pattern signature against res_ty
-	; wrap <- tcSubType PatSigOrigin ctxt res_ty sig_ty
+        -- Now do a subsumption check of the pattern signature against res_ty
+        ; wrap <- tcSubType PatSigOrigin ctxt res_ty sig_ty
 
-	-- Phew!
+        -- Phew!
         ; return (sig_ty, sig_tvs, wrap)
         } }
 
@@ -1744,17 +1738,17 @@ tc_kind_var_app name arg_kis
 tc_kind_var_app name arg_kis
   = do { thing <- tcLookup name
        ; case thing of
-  	   AGlobal (ATyCon tc)
-  	     -> do { data_kinds <- xoptM Opt_DataKinds
-  	           ; unless data_kinds $ addErr (dataKindsErr name)
-  	     	   ; case promotableTyCon_maybe tc of
-  	     	       Just prom_tc | arg_kis `lengthIs` tyConArity prom_tc
-  	     	               -> return (mkTyConApp prom_tc arg_kis)
-  	     	       Just _  -> tycon_err tc "is not fully applied"
-  	     	       Nothing -> tycon_err tc "is not promotable" }
-
-  	   -- A lexically scoped kind variable
-  	   ATyVar _ kind_var 
+           AGlobal (ATyCon tc)
+             -> do { data_kinds <- xoptM Opt_DataKinds
+                   ; unless data_kinds $ addErr (dataKindsErr name)
+                   ; case promotableTyCon_maybe tc of
+                       Just prom_tc | arg_kis `lengthIs` tyConArity prom_tc
+                               -> return (mkTyConApp prom_tc arg_kis)
+                       Just _  -> tycon_err tc "is not fully applied"
+                       Nothing -> tycon_err tc "is not promotable" }
+
+           -- A lexically scoped kind variable
+           ATyVar _ kind_var 
              | not (isKindVar kind_var) 
              -> failWithTc (ptext (sLit "Type variable") <+> quotes (ppr kind_var)
                             <+> ptext (sLit "used as a kind"))
@@ -1765,19 +1759,19 @@ tc_kind_var_app name arg_kis
              | otherwise 
              -> return (mkAppTys (mkTyVarTy kind_var) arg_kis)
 
-  	   -- It is in scope, but not what we expected
-  	   AThing _ 
+           -- It is in scope, but not what we expected
+           AThing _ 
              | isTyVarName name 
              -> failWithTc (ptext (sLit "Type variable") <+> quotes (ppr name)
                             <+> ptext (sLit "used in a kind"))
              | otherwise 
              -> failWithTc (hang (ptext (sLit "Type constructor") <+> quotes (ppr name)
                                   <+> ptext (sLit "used in a kind"))
-  	                       2 (ptext (sLit "inside its own recursive group"))) 
+                               2 (ptext (sLit "inside its own recursive group"))) 
 
            APromotionErr err -> promotionErr name err
 
-  	   _ -> wrongThingErr "promoted type" thing name
+           _ -> wrongThingErr "promoted type" thing name
                 -- This really should not happen
      }
   where 
@@ -1801,15 +1795,15 @@ promotionErr name err
 \end{code}
 
 %************************************************************************
-%*									*
-		Scoped type variables
-%*									*
+%*                                                                      *
+                Scoped type variables
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 pprHsSigCtxt :: UserTypeCtxt -> LHsType Name -> SDoc
 pprHsSigCtxt ctxt hs_ty = sep [ ptext (sLit "In") <+> pprUserTypeCtxt ctxt <> colon, 
-				 nest 2 (pp_sig ctxt) ]
+                                 nest 2 (pp_sig ctxt) ]
   where
     pp_sig (FunSigCtxt n)  = pp_n_colon n
     pp_sig (ConArgCtxt n)  = pp_n_colon n
@@ -1822,8 +1816,8 @@ badPatSigTvs :: TcType -> [TyVar] -> SDoc
 badPatSigTvs sig_ty bad_tvs
   = vcat [ fsep [ptext (sLit "The type variable") <> plural bad_tvs, 
                  quotes (pprWithCommas ppr bad_tvs), 
-          	 ptext (sLit "should be bound by the pattern signature") <+> quotes (ppr sig_ty),
-	  	 ptext (sLit "but are actually discarded by a type synonym") ]
+                 ptext (sLit "should be bound by the pattern signature") <+> quotes (ppr sig_ty),
+                 ptext (sLit "but are actually discarded by a type synonym") ]
          , ptext (sLit "To fix this, expand the type synonym") 
          , ptext (sLit "[Note: I hope to lift this restriction in due course]") ]
 
diff --git a/compiler/typecheck/TcInstDcls.lhs b/compiler/typecheck/TcInstDcls.lhs
index 6b4cb8e..c56581f 100644
--- a/compiler/typecheck/TcInstDcls.lhs
+++ b/compiler/typecheck/TcInstDcls.lhs
@@ -6,12 +6,6 @@
 TcInstDecls: Typechecking instance declarations
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcInstDcls ( tcInstDecls1, tcInstDecls2 ) where
 
@@ -566,8 +560,8 @@ tcClsInstDecl (L loc (ClsInstDecl { cid_poly_ty = poly_ty, cid_binds = binds
 
         ; overlap_flag <- getOverlapFlag
         ; (subst, tyvars') <- tcInstSkolTyVars tyvars
-        ; let dfun  	= mkDictFunId dfun_name tyvars theta clas inst_tys
-              ispec 	= mkLocalInstance dfun overlap_flag tyvars' clas (substTys subst inst_tys)
+        ; let dfun      = mkDictFunId dfun_name tyvars theta clas inst_tys
+              ispec     = mkLocalInstance dfun overlap_flag tyvars' clas (substTys subst inst_tys)
                             -- Be sure to freshen those type variables, 
                             -- so they are sure not to appear in any lookup
               inst_info = InstInfo { iSpec  = ispec, iBinds = VanillaInst binds uprags False }
@@ -1387,13 +1381,13 @@ tcInstanceMethods dfun_id clas tyvars dfun_ev_vars inst_tys
 ------------------
 mkGenericDefMethBind :: Class -> [Type] -> Id -> Name -> TcM (LHsBind Name)
 mkGenericDefMethBind clas inst_tys sel_id dm_name
-  = 	-- A generic default method
-    	-- If the method is defined generically, we only have to call the
+  =     -- A generic default method
+        -- If the method is defined generically, we only have to call the
         -- dm_name.
-    do	{ dflags <- getDynFlags
-	; liftIO (dumpIfSet_dyn dflags Opt_D_dump_deriv "Filling in method body"
-		   (vcat [ppr clas <+> ppr inst_tys,
-			  nest 2 (ppr sel_id <+> equals <+> ppr rhs)]))
+    do  { dflags <- getDynFlags
+        ; liftIO (dumpIfSet_dyn dflags Opt_D_dump_deriv "Filling in method body"
+                   (vcat [ppr clas <+> ppr inst_tys,
+                          nest 2 (ppr sel_id <+> equals <+> ppr rhs)]))
 
         ; return (noLoc $ mkTopFunBind (noLoc (idName sel_id))
                                        [mkSimpleMatch [] rhs]) }
